<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Observer;
 
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;
use Magento\Framework\App\RequestInterface;

class OnProductSave implements ObserverInterface
{
    /** @var \Magento\Framework\Logger\Monolog */
    protected $_logger;

    /** @var \Webkul\Eshopsync\Helper\Connection */
    protected $_helperConnection;

    /** @var \Webkul\Eshopsync\Helper\Product */
    protected $_helperProduct;

    /** @var \Webkul\Eshopsync\Helper\Data */
    protected $_helperData;

    /** @var Magento\Framework\App\RequestInterface */
    protected $_request;

    /** @var \Webkul\Eshopsync\Model\ProductFactory */
    protected $_eshopsyncProduct;

    /** @var \Magento\Catalog\Model\CategoryFactory */
    protected $_catalogCategory;

    /**
     * @param \Psr\Log\LoggerInterface                   $loggerInterface
     * @param \Webkul\Eshopsync\Helper\Connection        $helperConnection
     * @param \Webkul\Eshopsync\Helper\Product           $helperProduct
     * @param \Webkul\Eshopsync\Helper\Data              $helperData
     * @param RequestInterface                           $requestInterface
     * @param \Webkul\Eshopsync\Model\ProductFactory     $eshopsyncProduct
     * @param \Magento\Catalog\Model\CategoryFactory     $catalogCategory
     */
    public function __construct(
        \Psr\Log\LoggerInterface $loggerInterface,
        \Webkul\SalesforceConnector\Helper\Connection $helperConnection,
        \Webkul\SalesforceConnector\Helper\Product $helperProduct,
        \Webkul\SalesforceConnector\Helper\Data $helperData,
        RequestInterface $requestInterface,
        \Webkul\SalesforceConnector\Model\ProductFactory $eshopsyncProduct,
        \Magento\Catalog\Model\CategoryFactory $catalogCategory
    ) {
        $this->_logger = $loggerInterface;
        $this->_helperConnection = $helperConnection;
        $this->_helperProduct = $helperProduct;
        $this->_helperData = $helperData;
        $this->_request = $requestInterface;
        $this->_eshopsyncProduct = $eshopsyncProduct;
        $this->_catalogCategory = $catalogCategory;
    }
    /**
     * This is the method that fires when the event runs.
     *
     * @param Observer $observer
     */

    public function execute(Observer $observer)
    {
        $proId = $observer->getEvent()->getProduct()->getId();
        $controller = $this->_request->getControllerName();
        if ($controller == "product" && $proId) {
            // $mappingId = 0;
            // $client = $this->_helperConnection->getSforceConnection();
            
            $autoSync = $this->_helperData->getConfigValue('autoSync', 'autoSyncProSync');
            if ($autoSync) {
                $this->_helperProduct->syncSpecificProduct($proId);
            }
            // $model = $this->_helperProduct;
            // $data =  $this->_helperData->fetchMappingDetails($this->_eshopsyncProduct, $proId);
            // if (count($data) > 0) {
            //     $mappingId = $data['entity_id'];
                
            //     if (!$autoSync && $mappingId) {
            //         $model->updateMapping($mappingId, 'yes');
            //     }
            // }
            // if ($client['client'] && $autoSync) {
            //     $action = "Export";
            //     if ($mappingId) {
            //         $action = 'Update';
            //     }
            //     /* sync specific product...*/
            //     $model->syncSpecificProduct($client['client'], $proId, $action, $mappingId);
            // }
        }
        return true;
    }
}
